<template>
  <!--This page is shown if the user wants a add an question that is not in the template.
        So there is an input field for the question and a list of options where options can be added or
        removed and a textfield to answer a question. -->
  <div
    :style="'height: ' + ($vuetify.breakpoint.height - 114) + 'px;'"
    id="scroll-target-list"
  >
    <v-row>
      <v-col cols="8">
        <p class="text">Frage</p>
        <v-text-field
          counter="50"
          class="inputQuestion"
          v-model="text"
          placeholder="Frage hinzufügen"
          :maxlength="max"
        />
      </v-col>
    </v-row>

    <p class="text">Antworttyp</p>
    <v-menu Auswahl>
      <template v-slot:activator="{ on }">
        <v-btn tile depressed class="options" v-on="on">{{ german }}</v-btn>
      </template>

      <v-list>
        <v-list-item @click="setType('date', 'Datum')">
          <v-list-item-title>Datum</v-list-item-title>
        </v-list-item>

        <v-list-item @click="setType('number', 'Zahl')">
          <v-list-item-title>Zahl</v-list-item-title>
        </v-list-item>

        <v-list-item @click="setType('text', 'Text')">
          <v-list-item-title>Text</v-list-item-title>
        </v-list-item>

        <v-list-item @click="setType('select', 'Auswahl')">
          <v-list-item-title>Auswahl</v-list-item-title>
        </v-list-item>
      </v-list>
    </v-menu>

    <div class="options-block">
      <div v-if="type === 'select'">
        <v-list>
          <v-list-item v-for="option in options" :key="option.id">
            <p class="option">Option</p>

            <div>
              <v-text-field
                type="text"
                class="input"
                placeholder="Antwortmöglichkeit"
                :maxlength="20"
                v-model="option.text"
              />
            </div>

            <v-btn
              aria-label="Option löschen"
              class="minusbox"
              icon
              minus
              @click="removeOption(option)"
            >
              <v-icon color="primary">mdi-minus-box</v-icon>
            </v-btn>
          </v-list-item>
        </v-list>
        <v-btn
          aria-label="Option hinzufügen"
          class="addQuestion"
          icon
          @click="addOption()"
        >
          <v-icon color="primary" x-large>mdi-plus-box</v-icon>
        </v-btn>
      </div>
    </div>

    <v-row class="bottom-buttons">
      <v-spacer></v-spacer>
      <v-col>
        <v-btn
          tile
          depressed
          class="btnExit ml-12"
          color="rgb(12, 12, 12, 0.1)"
          @click="closeAddQuestion()"
          >Abbrechen</v-btn
        >
        <v-btn
          tile
          depressed
          class="btnAdd ml-3"
          color="primary"
          @click="createNewQuestionObject()"
          >Hinzufügen</v-btn
        >
      </v-col>
    </v-row>
  </div>
</template>

<script>
export default {
  name: "QuestionAdd",
  data() {
    return {
      text: "",
      max: 50,
      maxString: "/",
      options: [
        { id: 0, text: "" },
        { id: 1, text: "" }
      ],
      type: "text",
      german: "Text",
      optionCounter: 2
    };
  },
  methods: {
    //this method adds the new created question to the template and the list of selected questions.
    createNewQuestionObject: function() {
      let newQuestion = {
        abbrv: this.text.substring(0, 10),
        comment: "true",
        dependent_on: "none",
        expected_answer: "none",
        number: this.$store.state.questions.question.length + 1,
        required: "false",
        score: "false",
        text: this.text,
        type: this.type
      };
      if (this.type === "select") {
        let options = {};
        for (let option of this.options) {
          options[option.text] = option.text;
        }
        newQuestion["options"] = options;
      } else {
        newQuestion["options"] = "none";
      }
      this.$store.dispatch("addNewSelfCreatedQuestionObject", newQuestion);
      this.closeAddQuestion();
    },
    //here a question can be canceled
    closeAddQuestion: function() {
      this.$store.dispatch("showQuestionListObject");
    },
    //the addOption function adds another option to the question.
    addOption: function() {
      this.options.push({ id: this.optionCounter, text: "" });
      this.optionCounter++;
    },
    //the removeOption function removes an already created option.
    removeOption: function(option) {
      const qs = this.options.indexOf(option);
      if (qs > -1) {
        this.options.splice(qs, 1);
      }
    },
    //sets type of question and its german name
    setType: function(type, german) {
      this.type = type;
      this.german = german;
    }
  }
};
</script>

<style scoped>
@media only screen and (min-width: 600px) {
  .inputQuestion {
    min-height: 40px;
    background-color: white;
    margin-bottom: 10px;
    font-size: 20px;
    margin-left: 55px;
    min-width: 600px;
    text-indent: 2px;
    margin-right: 50%;
  }

  .text {
    margin-top: 30px;
    margin-bottom: 0;
    font-size: 14px;
    text-indent: 55px;
    color: #6c6c6c;
  }

  .options {
    margin-left: 55px;
    text-indent: 0;
    margin-bottom: 150px;
  }

  .option {
    text-indent: 40px;
  }

  .input {
    margin-left: 55px;
  }

  .addQuestion {
    margin-left: 200px;
    margin-bottom: 50px;
  }

  .minusbox {
    margin-left: 10px;
  }

  #scroll-target-list {
    overflow-x: hidden;
    overflow-y: scroll;
  }
}
</style>
